## mingw-w64-ptex-2.4.3-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8.0)
project(Ptex)

option(PTEX_BUILD_STATIC_LIBS "Enable building Ptex static libraries" ON)
option(PTEX_BUILD_SHARED_LIBS "Enable building Ptex shared libraries" ON)
option(PTEX_BUILD_DOCS "Enable building Ptex documentation (require Doxygen)" ON)
option(PRMAN_15_COMPATIBLE_PTEX "Enable PRMan 15 compatibility" OFF)

# The C++ standard can set either through the environment or by specifyign
# CMAKE_CXX_STANDARD when configuring the project using "cmake".
if (NOT DEFINED CMAKE_CXX_STANDARD)
    # export CXXFLAGS_STD=c++17 in the environment to enable C++17.
    if (DEFINED ENV{CXXFLAGS_STD})
        string(SUBSTRING "$ENV{CXXFLAGS_STD}" 3 -1 cxx_standard)
        set(CMAKE_CXX_STANDARD "${cxx_standard}")
    else ()
        set(CMAKE_CXX_STANDARD 98)
    endif ()
endif()
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_FIND_PACKAGE_RESOLVE_SYMLINKS ON)
set(CMAKE_INSTALL_MESSAGE LAZY)
set(CMAKE_THREAD_PREFER_PTHREAD ON)
set(THREADS_PREFER_PTHREAD_FLAG ON)

include(GNUInstallDirs)

include(CTest)
enable_testing()

# Setup platform-specific threading flags.
find_package(Threads REQUIRED)

find_package(ZLIB REQUIRED)

if (NOT DEFINED PTEX_SHA)
    # Query git for current commit ID
    execute_process(
        COMMAND git rev-parse HEAD
        WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
        OUTPUT_VARIABLE PTEX_SHA
        OUTPUT_STRIP_TRAILING_WHITESPACE)
endif ()

if (NOT DEFINED PTEX_VER)
    # Get the version string from a "version" file or from git
    if (EXISTS "${PROJECT_SOURCE_DIR}/version")
        file(STRINGS "${PROJECT_SOURCE_DIR}/version" PTEX_VER)
    else ()
        execute_process(
            COMMAND git describe --match=v[0-9]*.[0-9]* --first-parent HEAD
            WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
            OUTPUT_VARIABLE PTEX_VER
            OUTPUT_STRIP_TRAILING_WHITESPACE)
    endif ()
endif ()
# Provide a fallback version when the Git repository is unavailable.
if (NOT PTEX_VER)
    set(PTEX_VER "v2.4.X")
endif()

# Transform PTEX_VER into PTEX_MAJOR_VERSION and PTEX_MINOR_VERSION
string(REPLACE "v" "" PTEX_VER_STRIPPED ${PTEX_VER})  # strip leading "v"
string(REPLACE "." ";" PTEX_VER_LIST ${PTEX_VER_STRIPPED})
list(LENGTH PTEX_VER_LIST PTEX_VER_LENGTH)
if (${PTEX_VER_LENGTH} LESS 2)
    message(FATAL_ERROR "Could not determine the Ptex library version")
endif ()

# The version variables are used to generate PtexVersion.h
list(GET PTEX_VER_LIST 0 PTEX_MAJOR_VERSION)
list(GET PTEX_VER_LIST 1 PTEX_MINOR_VERSION)

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    # Detect the build type from the $FLAVOR environment variable
    # Default to optimized Release builds when unspecified.
    if ("$ENV{FLAVOR}" MATCHES "debug")
        set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "type of build" FORCE)
    elseif ("$ENV{FLAVOR}" MATCHES "profile")
        set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "type of build" FORCE)
    else ()
        set(CMAKE_BUILD_TYPE "Release" CACHE STRING "type of build" FORCE)
    endif ()
endif ()

if (NOT WIN32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic")
endif ()

if (MSVC)
    add_definitions(
        # forcing value to bool 'true' or 'false' (performance warning)
        /wd4800
        # conversion from 'double' to 'float', possible loss of data
        /wd4244
        /D_CRT_SECURE_NO_WARNINGS
    )
endif()

# Set the default Ptex library to use for tools and tests.
if (PTEX_BUILD_STATIC_LIBS)
    set(PTEX_LIBRARY Ptex_static)
else()
    set(PTEX_LIBRARY Ptex_dynamic)
endif()

if (${PRMAN_15_COMPATIBLE_PTEX})
    add_definitions(-DPTEX_NO_LARGE_METADATA_BLOCKS)
endif ()

include_directories(src/ptex)

add_subdirectory(src/ptex)
add_subdirectory(src/utils)
add_subdirectory(src/tests)
if (PTEX_BUILD_DOCS)
    add_subdirectory(src/doc)
endif ()
add_subdirectory(src/build)

=== Makefile ===
#!/usr/bin/env make
# prefix=<path> specifies the installation prefix (ex: /usr/local)
# DESTDIR=<path> specifies the temporary staging directory (ex: /tmp/stage)
# V=1 or VERBOSE=1 enables verbose builds
# NO_NINJA=1 disables autodetection and use of ninja
# PRMAN_15_COMPATIBLE_PTEX=1 enables compatibility with PRman 15
# FLAVOR={opt,debug,profile} sets CMAKE_BUILD_TYPE using short aliases
# BUILD_TYPE={Release,Debug,RelWithDebInfo} sets CMAKE_BUILD_TYPE directly

FLAGS =
FLAVOR ?= optimize
uname_S := $(shell sh -c 'uname -s || echo kernel')
uname_R := $(shell sh -c '(uname -r || echo release) | cut -d- -f1')
uname_M := $(shell sh -c 'uname -m || echo machine')
platform ?= $(uname_S)-$(uname_R)-$(uname_M)-$(FLAVOR)
build = build/$(platform)
# Installation prefix
prefix = $(CURDIR)/$(platform)
CMAKE_FLAGS += -DCMAKE_INSTALL_PREFIX=$(prefix)
TEST_FLAGS = --output-on-failure --force-new-ctest-process

ifdef V
    VERBOSE = 1
endif
ifndef VERBOSE
    QUIET = @
endif

# Ninja auto-detection
NO_NINJA := $(shell sh -c '(type ninja >/dev/null && echo 0) || echo 1')
ifeq ($(NO_NINJA),1)
    CMAKE_FLAGS += -G "Unix Makefiles"
    FLAGS += -- --no-print-directory
else
    CMAKE_FLAGS += -G Ninja
    FLAGS += $(shell sh -c '\
        VERBOSE=$(VERBOSE) ./src/build/ninja-flags.sh $(MAKEFLAGS)')
endif
ifdef PRMAN_15_COMPATIBLE_PTEX
    CMAKE_FLAGS += -DPRMAN_15_COMPATIBLE_PTEX:BOOL=TRUE
endif
ifdef TOOLCHAIN
    CMAKE_FLAGS += -DCMAKE_TOOLCHAIN_FILE=$(TOOLCHAIN)
endif
ifdef BUILD_TYPE
    CMAKE_FLAGS += -DCMAKE_BUILD_TYPE=$(BUILD_TYPE)
endif
ifdef BUILD_SHARED_LIBS
    CMAKE_FLAGS += -DPTEX_BUILD_SHARED_LIBS=$(BUILD_SHARED_LIBS)
endif
ifdef BUILD_STATIC_LIBS
    CMAKE_FLAGS += -DPTEX_BUILD_SHARED_LIBS=$(BUILD_STATIC_LIBS)
endif

# Targets
default:: test

test:: all

clean:: uninstall

configure = $(build)/cmake.conf
$(configure):
	$(QUIET)mkdir -p $(build)
	$(QUIET)cd $(build) && cmake $(CMAKE_FLAGS) $(CURDIR)
	$(QUIET)touch $@

cmake:
	$(QUIET)mkdir -p $(build)
	$(QUIET)cd $(build) && cmake $(CMAKE_FLAGS) $(CURDIR)

all clean doc doxygen install:: $(configure)
	+$(QUIET)cmake --build $(build) --target $@ $(FLAGS)

test:: $(configure)
	+$(QUIET)cd $(build) && ctest $(TEST_FLAGS) $(flags)

install::
	$(QUIET)cp $(build)/install_manifest.txt $(build).manifest.txt

uninstall: $(configure)
	$(QUIET)touch $(build).manifest.txt
	$(QUIET)xargs rm -f <$(build).manifest.txt
	$(QUIET)xargs dirname <$(build).manifest.txt 2>/dev/null | \
	sort -u -r | xargs rmdir -p >/dev/null 2>&1 || true

=== src/build/CMakeLists.txt ===
include(CMakePackageConfigHelpers)

set(CMAKE_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/Ptex")

write_basic_package_version_file("ptex-config-version.cmake"
    VERSION "${PTEX_MAJOR_VERSION}.${PTEX_MINOR_VERSION}"
    COMPATIBILITY AnyNewerVersion)

configure_package_config_file(
    "ptex-config.cmake" "ptex-config.cmake"
    INSTALL_DESTINATION "${CMAKE_DIR}" PATH_VARS
    CMAKE_INSTALL_PREFIX CMAKE_INSTALL_LIBDIR CMAKE_INSTALL_INCLUDEDIR)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ptex-config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/ptex-config-version.cmake"
    DESTINATION "${CMAKE_DIR}" COMPONENT "devel")

install(EXPORT Ptex NAMESPACE Ptex::
    FILE "ptex-exports.cmake" DESTINATION "${CMAKE_DIR}" COMPONENT "devel")

if (IS_ABSOLUTE "${CMAKE_INSTALL_LIBDIR}")
    set(CMAKE_INSTALL_PKGCONFIG_LIBDIR "${CMAKE_INSTALL_LIBDIR}")
else()
    set(CMAKE_INSTALL_PKGCONFIG_LIBDIR "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
endif()
if (IS_ABSOLUTE "${CMAKE_INSTALL_INCLUDEDIR}")
    set(CMAKE_INSTALL_PKGCONFIG_INCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}")
else()
    set(CMAKE_INSTALL_PKGCONFIG_INCLUDEDIR "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
endif()

string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWERCASE)

if (PTEX_BUILD_SHARED_LIBS)
    get_target_property(PTEX_OUTPUT_NAME Ptex_dynamic OUTPUT_NAME)
else()
    get_target_property(PTEX_OUTPUT_NAME Ptex_static OUTPUT_NAME)
endif()
configure_file("${PROJECT_NAME_LOWERCASE}.pc.in" "${PROJECT_NAME_LOWERCASE}.pc" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME_LOWERCASE}.pc"
    COMPONENT devel DESTINATION share/pkgconfig)

=== PKGBUILD ===
# Maintainer: Andrew Sun <adsun701@gmail.com>

_realname=ptex
pkgbase=mingw-w64-${_realname}
pkgname=(
  "${MINGW_PACKAGE_PREFIX}-${_realname}"
  "${MINGW_PACKAGE_PREFIX}-${_realname}-docs"
)
pkgver=2.4.3
pkgrel=1
pkgdesc="Per-Face Texture Mapping for Production Rendering (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32' 'clangarm64')
url='https://ptex.us/'
msys2_references=(
  "cpe: cpe:/a:disneyanimation:ptex"
)
license=('spdx:BSD-3-Clause')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf"
             "${MINGW_PACKAGE_PREFIX}-doxygen")
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-zlib"
         "${MINGW_PACKAGE_PREFIX}-winpthreads")
source=("${_realname}-${pkgver}.tar.gz"::"https://github.com/wdas/${_realname}/archive/v${pkgver}.tar.gz"
        "0001-ptex-2.1.28-remove-msc_ver.patch"
        "0002-ptex-2.1.28-install-dll-correctly.patch"
        "0004-mingw-isfinite.patch")
sha256sums=('435aa2ee1781ff24859bd282b7616bfaeb86ca10604b13d085ada8aa7602ad27'
            'a0ee8547873a24bbe57a799a5cd895e91b786a926c8c3dba5d0771cca8c2d0a3'
            '1c6f78a9cb1eb790abaee2e43802a037b92abf9b41d54a6eb8a82f0d1a50457a'
            '2ffad92e3dae6647a5ae4dc7f4b1ad77297495fbf70825f86ea6490c884822f9')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}
  apply_patch_with_msg \
    0001-ptex-2.1.28-remove-msc_ver.patch \
    0002-ptex-2.1.28-install-dll-correctly.patch \
    0004-mingw-isfinite.patch

  cd src/doc
  ${MINGW_PREFIX}/bin/doxygen -u
}

build() {
  [[ -d "${srcdir}"/build-${MSYSTEM} ]] && rm -rf "${srcdir}"/build-${MSYSTEM}
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake \
      -G'Ninja' \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      "${extra_config[@]}" \
      -DPTEX_BUILD_SHARED_LIBS=ON \
      -DPTEX_BUILD_STATIC_LIBS=ON \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_ptex() {
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install "build-${MSYSTEM}"

  # split docs
  mkdir -p dest${MINGW_PREFIX}/share
  mv "${pkgdir}${MINGW_PREFIX}"/share/doc dest${MINGW_PREFIX}/share/doc
}

package_ptex-docs() {
  pkgdesc+=" (documentation)"
  depends=()

  mv dest/* "${pkgdir}"
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
